diff -ruN ../nakedmudv3.7/src/room.c src/room.c
--- ../nakedmudv3.7/src/room.c	2008-05-31 00:17:59.000000000 -0400
+++ src/room.c	2009-03-02 01:00:39.000000000 -0500
@@ -19,16 +19,12 @@
 #include "storage.h"
 #include "exit.h"
 #include "room.h"
-
-
-
-// room UIDs (unique IDs) start at a million and go 
-// up by one every time a new room is created
-#define START_ROOM_UID       1000000
-int next_room_uid  =   START_ROOM_UID;
+#include "character.h"
+#include "object.h"
 
 struct room_data {
   int         uid;               // what is our unique room ID number?
+  time_t      birth;             // the time we were created
   int         terrain;           // what kind of terrain do we have?
   char       *name;              // what is the name of our room?
   BUFFER     *desc;              // our description
@@ -43,7 +39,9 @@
   LIST       *contents;          // what objects do we contain in the room?
   LIST       *characters;        // who is in our room?
 
-  HASHTABLE  *auxiliary_data;    // data modules have installed in us
+  AUX_TABLE  *auxiliary_data;    // data modules have installed in us
+
+  bool        extracted;         // have we been extracted from the game?
 };
 
 
@@ -55,7 +53,8 @@
 ROOM_DATA *newRoom() {
   ROOM_DATA *room = malloc(sizeof(ROOM_DATA));
 
-  room->uid       = next_room_uid++;
+  room->uid       = next_uid();
+  room->birth     = current_time;
   room->prototypes= strdup("");
   room->name      = strdup("");
   room->class     = strdup("");
@@ -67,10 +66,11 @@
   room->auxiliary_data = newAuxiliaryData(AUXILIARY_TYPE_ROOM);
 
   room->exits      = newHashtable();
-  room->cmd_table  = newNearMap();
   room->edescs     = newEdescSet();
   room->contents   = newList();
   room->characters = newList();
+  room->extracted  = FALSE;
+  room->cmd_table  = NULL;
 
   return room;
 }
@@ -111,14 +111,16 @@
   deleteHashtable(room->exits);
 
   // delete all of our commands
-  NEAR_ITERATOR *cmd_i = newNearIterator(room->cmd_table);
-  const char      *key = NULL;
-  CMD_DATA        *cmd = NULL;
-  ITERATE_NEARMAP(key, cmd, cmd_i)
-    deleteCmd(cmd);
-  deleteNearIterator(cmd_i);
-  deleteNearMap(room->cmd_table);
-
+  if(room->cmd_table != NULL) {
+    NEAR_ITERATOR *cmd_i = newNearIterator(room->cmd_table);
+    const char      *key = NULL;
+    CMD_DATA        *cmd = NULL;
+    ITERATE_NEARMAP(key, cmd, cmd_i)
+      deleteCmd(cmd);
+    deleteNearIterator(cmd_i);
+    deleteNearMap(room->cmd_table);
+  }
+    
   // delete extra descriptions
   if(room->edescs) deleteEdescSet(room->edescs);
 
@@ -146,6 +148,7 @@
   store_string(set, "terrain",    terrainGetName(room->terrain));
   store_set   (set, "edescs",     edescSetStore(room->edescs));
   store_list  (set, "exits",      ex_list);
+  store_long  (set, "birth",      room->birth);
 
   // store all of our exits. We're doing this in an odd way by putting the
   // direction name on the storage set for the exit. They should probably be
@@ -160,8 +163,26 @@
     store_string(ex_set, "direction", dir);
     storage_list_put(ex_list, ex_set);
   } deleteHashIterator(ex_i);
+  
+  // store our auxiliary data
+  store_set(set, "auxiliary", auxiliaryDataStore(room->auxiliary_data));
+
+  // store all of our characters
+  if(listSize(roomGetCharacters(room)) > 0) {
+    LIST_ITERATOR      *ch_i = newListIterator(roomGetCharacters(room));
+    CHAR_DATA            *ch = NULL;
+    STORAGE_SET_LIST *chlist = new_storage_list();
+    ITERATE_LIST(ch, ch_i) {
+      if(charIsNPC(ch))
+	storage_list_put(chlist, charStore(ch));
+    } deleteListIterator(ch_i);
+    store_list(set, "chars", chlist);
+  }
+
+  // and all of our objects
+  if(listSize(roomGetContents(room)) > 0)
+    store_list(set, "objs", gen_store_list(room->contents, objStore));
 
-  store_set   (set, "auxiliary", auxiliaryDataStore(room->auxiliary_data));
   return set;
 }
 
@@ -178,6 +199,9 @@
   roomSetEdescs(room,     edescSetRead(read_set   (set, "edescs")));
   bitSet(room->bits,      read_string(set, "room_bits"));
 
+  if(storage_contains(set, "birth"))
+    room->birth = read_long(set, "birth");
+
   // parse and add all of our exits
   while( (ex_set = storage_list_next(ex_list)) != NULL)
     roomSetExit(room, read_string(ex_set, "direction"), exitRead(ex_set));
@@ -185,6 +209,29 @@
   deleteAuxiliaryData(room->auxiliary_data);
   room->auxiliary_data = auxiliaryDataRead(read_set(set, "auxiliary"), 
 					   AUXILIARY_TYPE_ROOM);
+
+  // read all of our characters
+  if(storage_contains(set, "chars")) {
+    deleteList(room->characters);
+    room->characters    = gen_read_list(read_list(set, "chars"), charRead);
+    CHAR_DATA       *ch = NULL;
+    LIST_ITERATOR *ch_i = newListIterator(room->characters);
+    ITERATE_LIST(ch, ch_i) {
+      charSetRoom(ch, room);
+    } deleteListIterator(ch_i);
+  }
+
+  // and all of our objects
+  if(storage_contains(set, "objs")) {
+    deleteList(room->contents);
+    room->contents = gen_read_list(read_list(set, "objs"), objRead);
+    OBJ_DATA        *obj = NULL;
+    LIST_ITERATOR *obj_i = newListIterator(room->contents);
+    ITERATE_LIST(obj, obj_i) {
+      objSetRoom(obj, room);
+    } deleteListIterator(obj_i);
+  }
+
   return room;
 }
 
@@ -207,6 +254,7 @@
   roomSetDesc      (to, roomGetDesc(from));
   roomSetTerrain   (to, roomGetTerrain(from));
   bitvectorCopyTo  (from->bits, to->bits);
+  to->birth = from->birth;
 
   // set our edescs
   roomSetEdescs(to, edescSetCopy(from->edescs));
@@ -238,24 +286,40 @@
   } deleteHashIterator(ex_i);
 
   // delete all of our old commands
-  NEAR_ITERATOR *cmd_i = newNearIterator(to->cmd_table);
-  const char   *abbrev = NULL;
-  CMD_DATA        *cmd = NULL;
-  ITERATE_NEARMAP(abbrev, cmd, cmd_i) {
-    nearMapRemove(to->cmd_table, cmdGetName(cmd));
-    deleteCmd(cmd);
-  } deleteNearIterator(cmd_i);
+  if(to->cmd_table != NULL) {
+    NEAR_ITERATOR *cmd_i = newNearIterator(to->cmd_table);
+    const char   *abbrev = NULL;
+    CMD_DATA        *cmd = NULL;
+    ITERATE_NEARMAP(abbrev, cmd, cmd_i) {
+      nearMapRemove(to->cmd_table, cmdGetName(cmd));
+      deleteCmd(cmd);
+    } deleteNearIterator(cmd_i);
+  }
 
   // now, copy in all of our new commands
-   cmd_i = newNearIterator(from->cmd_table);
-   ITERATE_NEARMAP(abbrev, cmd, cmd_i) {
-     nearMapPut(to->cmd_table, cmdGetName(cmd), abbrev, cmdCopy(cmd));
-   } deleteNearIterator(cmd_i);
+  if(from->cmd_table != NULL) {
+    if(to->cmd_table == NULL)
+      to->cmd_table = newNearMap();
+    NEAR_ITERATOR *cmd_i = newNearIterator(from->cmd_table);
+    const char   *abbrev = NULL;
+    CMD_DATA        *cmd = NULL;
+    ITERATE_NEARMAP(abbrev, cmd, cmd_i) {
+      nearMapPut(to->cmd_table, cmdGetName(cmd), abbrev, cmdCopy(cmd));
+    } deleteNearIterator(cmd_i);
+  }
   
   // copy all of our auxiliary data
   auxiliaryDataCopyTo(from->auxiliary_data, to->auxiliary_data);
 }
 
+void roomSetExtracted(ROOM_DATA *room) {
+  room->extracted = TRUE;
+}
+
+bool roomIsExtracted(ROOM_DATA *room) {
+  return room->extracted;
+}
+
 bool roomIsInstance(ROOM_DATA *room, const char *prototype) {
   return is_keyword(room->prototypes, prototype, FALSE);
 }
@@ -374,6 +438,10 @@
   return room->uid;
 }
 
+time_t      roomGetBirth       (const ROOM_DATA *room) {
+  return room->birth;
+}
+
 EDESC_SET  *roomGetEdescs      (const ROOM_DATA *room) {
   return room->edescs;
 }
@@ -385,7 +453,7 @@
 }
 
 void *roomGetAuxiliaryData     (const ROOM_DATA *room, const char *name) {
-  return hashGet(room->auxiliary_data, name);
+  return auxiliaryGet(room->auxiliary_data, name);
 }
 
 void        roomSetEdescs      (ROOM_DATA *room, EDESC_SET *edescs) {
@@ -415,6 +483,38 @@
   return room->cmd_table;
 }
 
+bool roomHasCmds(const ROOM_DATA *room) {
+  return room->cmd_table != NULL;
+}
+
+bool roomHasCmd(const ROOM_DATA *room, const char *name) {
+  return room->cmd_table != NULL && nearMapKeyExists(room->cmd_table, name);
+}
+
+CMD_DATA *roomRemoveCmd(ROOM_DATA *room, const char *name) {
+  if(room->cmd_table != NULL)
+    return nearMapRemove(room->cmd_table, name);
+  return NULL;
+}
+
+CMD_DATA *roomGetCmd(ROOM_DATA *room, const char *name, bool abbr_ok) {
+  if(room->cmd_table != NULL)
+    return nearMapGet(room->cmd_table, name, abbr_ok);
+  return NULL;
+}
+
+void roomAddCmd(ROOM_DATA *room, const char *name, 
+		const char *abbr, CMD_DATA *cmd) {
+  CMD_DATA *old = NULL;
+  if(room->cmd_table == NULL)
+    room->cmd_table = newNearMap();
+  else
+    old = nearMapRemove(room->cmd_table, name);
+  nearMapPut(room->cmd_table, name, abbr, cmd);
+  if(old != NULL)
+    deleteCmd(old);
+}
+
 
 
 //*****************************************************************************
@@ -479,6 +579,7 @@
 }
 
 
+
 //*****************************************************************************
 //
 // terrain stuff
diff -ruN ../nakedmudv3.7/src/room.h src/room.h
--- ../nakedmudv3.7/src/room.h	2008-05-31 00:17:59.000000000 -0400
+++ src/room.h	2009-03-02 01:00:39.000000000 -0500
@@ -120,7 +120,16 @@
 LIST       *roomGetContents     (const ROOM_DATA *room);
 BITVECTOR  *roomGetBits         (const ROOM_DATA *room);
 int         roomGetUID          (const ROOM_DATA *room);
+time_t      roomGetBirth        (const ROOM_DATA *room);
 NEAR_MAP   *roomGetCmdTable     (const ROOM_DATA *room);
+bool        roomHasCmds         (const ROOM_DATA *room);
+bool        roomHasCmd          (const ROOM_DATA *room, const char *name);
+void        roomAddCmd          (ROOM_DATA *room, const char *name, 
+				 const char *abbr, CMD_DATA *cmd);
+CMD_DATA   *roomRemoveCmd       (ROOM_DATA *room, const char *name);
+CMD_DATA   *roomGetCmd          (ROOM_DATA *room, const char *name, 
+				 bool abbr_ok);
+
 
 const char *roomGetClass       (ROOM_DATA *room);
 void        roomSetClass       (ROOM_DATA *room, const char *prototype);
@@ -129,6 +138,8 @@
 void        roomSetName        (ROOM_DATA *room, const char *name);
 void        roomSetDesc        (ROOM_DATA *room, const char *desc);
 void        roomSetTerrain     (ROOM_DATA *room, int terrain_type);
+void        roomSetExtracted   (ROOM_DATA *room);
+bool        roomIsExtracted    (ROOM_DATA *room);
 
 
 
diff -ruN ../nakedmudv3.7/src/room_reset.c src/room_reset.c
--- ../nakedmudv3.7/src/room_reset.c	2008-12-06 00:20:20.000000000 -0500
+++ src/room_reset.c	2009-03-02 01:00:39.000000000 -0500
@@ -754,35 +754,55 @@
 //*****************************************************************************
 
 //
-// room reset hook. Whenever a room is reset, apply all of its reset rules
+// run all of the resets for a specified room
+void do_resets(ROOM_DATA *room) {
+  // first apply all of our prototype resets
+  LIST            *protos = parse_keywords(roomGetPrototypes(room));
+  LIST_ITERATOR  *proto_i = newListIterator(protos);
+  char             *proto = NULL;
+  RESET_LIST        *list = NULL;
+
+  // try to run each parent reset, and finally our own
+  ITERATE_LIST(proto, proto_i) {
+    if((list = worldGetType(gameworld, "reset", proto)) != NULL)
+      resetRunOn(resetListGetResets(list), room, INITIATOR_ROOM, get_key_locale(proto));
+  } deleteListIterator(proto_i);
+  deleteListWith(protos, free);
+}
+
+//
+// room reset hook. Whenever a room is reset, apply all of the reset rules for
+// it and its parent.
 void room_reset_hook(const char *info) {
+  ROOM_DATA *room = NULL;
+  hookParseInfo(info, &room);
+  if(room != NULL)
+    do_resets(room);
+}
+
+//
+// zone reset hook. Whenever a zone is reset, apply all of its reset rules for
+// each room in the zone.
+void zone_reset_hook(const char *info) {
   char  *zone_key = NULL;
   hookParseInfo(info, &zone_key);
   ZONE_DATA *zone = worldGetZone(gameworld, zone_key);
-  free(zone_key);
 
   LIST_ITERATOR *res_i = newListIterator(zoneGetResettable(zone));
   char           *name = NULL;
-  const char   *locale = zoneGetKey(zone);
-  RESET_LIST     *list = NULL;
+  const char   *locale = zone_key;
   ROOM_DATA      *room = NULL;
   ITERATE_LIST(name, res_i) {
     if((room = worldGetRoom(gameworld, get_fullkey(name, locale))) != NULL) {
-      // first apply all of our prototype resets
-      LIST            *protos = parse_keywords(roomGetPrototypes(room));
-      LIST_ITERATOR  *proto_i = newListIterator(protos);
-      char             *proto = NULL;
-
-      // try to run each parent reset, and finally our own
-      ITERATE_LIST(proto, proto_i) {
-	if((list = worldGetType(gameworld, "reset", proto)) != NULL)
-	  resetRunOn(resetListGetResets(list), room, INITIATOR_ROOM, locale);
-      } deleteListIterator(proto_i);
-      deleteListWith(protos, free);
+      do_resets(room);
     }
   } deleteListIterator(res_i);
+
+  // garbage collection
+  free(zone_key);
 }
 
 void init_room_reset(void) {
-  hookAdd("reset", room_reset_hook);
+  hookAdd("reset_zone", zone_reset_hook);
+  hookAdd("reset_room", room_reset_hook);
 }
diff -ruN ../nakedmudv3.7/src/save.c src/save.c
--- ../nakedmudv3.7/src/save.c	2008-05-31 00:17:59.000000000 -0400
+++ src/save.c	2009-03-02 01:00:39.000000000 -0500
@@ -128,22 +128,12 @@
   // a character with that name, or there is a character with that name in
   // storage. We'll check both of these.
   const char *fname = get_save_filename(name, FILETYPE_PFILE);
-  FILE *fl = fopen(fname, "r");
-  if(fl != NULL) {
-    fclose(fl);
-    return TRUE;
-  }
-  return FALSE;
+  return file_exists(fname);
 }
 
 bool account_exists(const char *name) {
   const char *fname = get_save_filename(name, FILETYPE_ACCOUNT);
-  FILE *fl = fopen(fname, "r");
-  if(fl != NULL) {
-    fclose(fl);
-    return TRUE;
-  }
-  return FALSE;
+  return file_exists(fname);
 }
 
 void save_pfile(CHAR_DATA *ch) {
diff -ruN ../nakedmudv3.7/src/scripts/module.mk src/scripts/module.mk
--- ../nakedmudv3.7/src/scripts/module.mk	2008-12-06 00:32:44.000000000 -0500
+++ src/scripts/module.mk	2009-03-02 12:51:12.000000000 -0500
@@ -103,7 +103,6 @@
 	scripts/pymud.c         \
 	scripts/pymudsys.c      \
 	scripts/pyhooks.c       \
-	scripts/pyolc.c         \
 	scripts/pyroom.c        \
 	scripts/pyexit.c        \
 	scripts/pyaccount.c     \
@@ -115,7 +114,8 @@
 	scripts/pyauxiliary.c   \
 	scripts/triggers.c      \
 	scripts/trigedit.c      \
-	scripts/trighooks.c
+	scripts/trighooks.c     \
+	scripts/pyolc.c
 
 
 # the top level directory of python.
diff -ruN ../nakedmudv3.7/src/scripts/pyaccount.c src/scripts/pyaccount.c
--- ../nakedmudv3.7/src/scripts/pyaccount.c	2008-05-31 00:17:59.000000000 -0400
+++ src/scripts/pyaccount.c	2009-03-02 01:00:40.000000000 -0500
@@ -289,6 +289,8 @@
 			"lists names of all characters tied to the account.");
     PyAccount_addMethod("getAuxiliary", PyAccount_get_auxiliary, METH_VARARGS,
 			"gets the account auxiliary data with given key.");
+    PyAccount_addMethod("aux", PyAccount_get_auxiliary, METH_VARARGS,
+			"gets the account auxiliary data with given key.");
 
     // add in all the getsetters and methods
     makePyType(&PyAccount_Type, pyaccount_getsetters, pyaccount_methods);
diff -ruN ../nakedmudv3.7/src/scripts/pyauxiliary.c src/scripts/pyauxiliary.c
--- ../nakedmudv3.7/src/scripts/pyauxiliary.c	2008-05-31 00:17:59.000000000 -0400
+++ src/scripts/pyauxiliary.c	2008-12-19 15:55:12.000000000 -0500
@@ -17,6 +17,7 @@
 #include "../auxiliary.h"
 
 #include "pystorage.h"
+#include "pyplugs.h"
 
 
 
@@ -45,6 +46,8 @@
   else {
     // create a new instance of the proto
     PyObject *instance = PyInstance_New(proto, NULL, NULL);
+    if(instance == NULL)
+      log_pyerr("Error with Python auxiliary new");
     return instance;
   }
 }
@@ -55,16 +58,22 @@
 
 void pyAuxiliaryDataCopyTo(PyObject *from, PyObject *to) {
   PyObject *retval = PyObject_CallMethod(from, "copyTo", "O", to);
+  if(retval == NULL)
+    log_pyerr("Error with Python auxiliary copyto");
   Py_XDECREF(retval);
 }
 
 PyObject *pyAuxiliaryDataCopy(PyObject *data) {
   PyObject *retval = PyObject_CallMethod(data, "copy", NULL);
+  if(retval == NULL)
+    log_pyerr("Error with Python auxiliary copy");
   return retval;
 }
 
 STORAGE_SET *pyAuxiliaryDataStore(PyObject *data) {
   PyObject  *pyset = PyObject_CallMethod(data, "store", NULL);
+  if(pyset == NULL)
+    log_pyerr("Error with Python auxiliary store");
   STORAGE_SET *set = NULL;
 
   // make sure the set exists
@@ -88,6 +97,8 @@
     PyObject  *pystore = newPyStorageSet(set);
     PyObject     *args = Py_BuildValue("(O)", newPyStorageSet(set));
     PyObject *instance = PyInstance_New(proto, args, NULL);
+    if(instance == NULL)
+      log_pyerr("Error with Python auxiliary read");
     Py_DECREF(args);
     Py_DECREF(pystore);
     return instance;
